import { Injectable } from '@angular/core';
import { of } from 'rxjs';
import { Observable } from 'rxjs';
import { UserAuthRequest } from '../models/user-auth-request';

@Injectable({
  providedIn: 'root'
})
export class AuthServiceService {

  constructor() { }

  authenticated: boolean = false;
  
  leagueManager: boolean = false;

  teamManager: boolean = false;

  authenticate(userAuthRequest: UserAuthRequest) {
    let username = userAuthRequest.username;
    let password = userAuthRequest.password;
    if (username === "testteam" && password === "pass") {
      this.authenticated = true;
      this.teamManager = true;
    }
    if (username === "testleague" && password === "pass") {
      this.authenticated = true;
      this.leagueManager = true;
    }
  }

  logOut() : Observable<boolean> {
    this.authenticated = false;
    this.teamManager = false;
    this.leagueManager = false;
    return of(true);
  }

  isAuthenticated(): Observable<boolean> {
    return of(this.authenticated);
  }

  isLeagueManager(): Observable<boolean> {
    return of(this.leagueManager);
  }

  isTeamManager(): Observable<boolean> {
    return of(this.teamManager);
  }
}
