import { ValueConverter } from '@angular/compiler/src/render3/view/template';
import { Injectable } from '@angular/core';
import { Observable, of } from 'rxjs';
import { CreateGame } from '../models/create-game';
import { Game } from '../models/game';
import { Team } from '../models/team';
import { UpdateGameWinner } from '../models/update-game-winner';

@Injectable({
  providedIn: 'root'
})
export class GameService {

  teams : Team[] = [
    {id: 1, name: 'Toronto Maple Leafs'},
    {id: 2, name: 'Boston Bruins'}
  ];

  games: Game[] = [
    {id: 1, gameDateTime: "2021-04-26T17:10:00Z", homeTeam: this.teams[0], awayTeam: this.teams[1], winner: this.teams[0], homeTeamScore: 2, awayTeamScore: 0},
    {id: 2, gameDateTime: "2021-05-26T17:10:00Z", homeTeam: this.teams[1], awayTeam: this.teams[0], winner: this.teams[1], homeTeamScore: 2, awayTeamScore: 4},
  ];

  constructor() { }

  getGames(): Observable<Game[]> {
    return of(this.games);
  }

  deleteGame(id: number) {
    this.games = this.games.filter((val, i, array) => val.id != id);
  }

  createGame(game: CreateGame): void {
    
  }

  updateGameScore(game: Game): void {
    
  }

  updateGameWinner(game: UpdateGameWinner): void {
    
  }
}
